package com;

import java.util.Random;

public class MatrixMult implements Runnable {
    private int matrix_a[][];
    private int matrix_b[][];
    private int matrix_r[][];
    private int size;
    private int bsize;
    private int init_n;

    public MatrixMult(int s) {
        size = s;
        matrix_a = new int[s][s];
        matrix_b = new int[s][s];
        matrix_r = new int[s][s];
        bsize = 50;

        Random random = new Random();

        int i, j;
        for (i = 0; i < size; i++) {
            for (j = 0; j < size; j++) {
                matrix_a[i][j] = random.nextInt(100);
                matrix_b[i][j] = random.nextInt(100);
                matrix_r[i][j] = random.nextInt(100);
            }
        }
    }

    @Override
    public void run() {
        matrix_r[0][0] = 1;
    }


    public void mm_ijk() {
        int i, j, k;
        int sum;

    /* $begin mm-ijk */
        for (i = 0; i < size; i++) {
            for (j = 0; j < size; j++) {
                sum = 0;
                for (k = 0; k < size; k++) {
                    sum += matrix_a[i][k]*matrix_b[k][j];
                }
                matrix_r[i][j] += sum;
            }
        }
    }

    public void mm_jik() {
        int i, j, k;
        int sum;

        for (j = 0; j < size; j++) {
            for (i = 0; i < size; i++) {
                sum = 0;
                for (k = 0; k < size; k++) {
                    sum += matrix_a[i][k]*matrix_b[k][j];
                }
                matrix_r[i][j] += sum;
            }
        }
    }

    public void mm_ikj() {
        int i, j, k;
        int r;

        for (i = 0; i < size; i++) {
            for (k = 0; k < size; k++) {
                r = matrix_a[i][k];
                for (j = 0; j < size; j++) {
                    matrix_r[i][j] += r*matrix_b[k][j];
                }
            }
        }
    }

    public void mm_kij() {
        int i, j, k;
        int r;

        for (k = 0; k < size; k++) {
            for (i = 0; i < size; i++) {
                r = matrix_a[i][k];
                for (j = 0; j < size; j++) {
                    matrix_r[i][j] += r*matrix_b[k][j];
                }
            }
        }
    }

    public void mm_kji() {
        int i, j, k;
        int r;

        for (k = 0; k < size; k++) {
            for (j = 0; j < size; j++) {
                r = matrix_b[k][j];
                for (i = 0; i < size; i++) {
                    matrix_r[i][j] += matrix_a[i][k]*r;
                }
            }
        }
    }

    public void mm_jki() {
        int i, j, k;
        int r;

        for (j = 0; j < size; j++) {
            for (k = 0; k < size; k++) {
                r = matrix_b[k][j];
                for (i = 0; i < size; i++) {
                    matrix_r[i][j] += matrix_a[i][k]*r;
                }
            }
        }
    }


    public void mm_bikj() {
        int i, j, k;
        int kk, jj;
        double r;

        int en = bsize*(size/bsize); /* Number of elements within normal blocks */
        for (i = 0; i < size; i++)
        for (j = 0; j < size; j++)
            matrix_r[i][j] = 0;
        /* Do blocks along k */
        for (kk = 0; kk < en; kk += bsize) {
        for (jj = 0; jj < en; jj += bsize) {
            for (i = 0; i < size; i++) {
            for (k = kk; k < kk + bsize; k++) {
                r = matrix_a[i][k];
                for (j = jj; j < jj + bsize; j++) {
                matrix_r[i][j] += r*matrix_b[k][j];
                }
            }
            }
        }

        /* Now finish remaining j values */
        for (i = 0; i < size; i++) {
            for (k = kk; k < kk + bsize; k++) {
            r = matrix_a[i][k];
            for (j = en; j < size; j++) {
                matrix_r[i][j] += r*matrix_b[k][j];
            }
            }
        }
        }

        /* Now finish remaining values of k */
        for (jj = 0; jj < en; jj += bsize) {
        for (i = 0; i < size; i++) {
            for (k = en; k < size; k++) {
            r = matrix_a[i][k];
            for (j = jj; j < jj + bsize; j++) {
                matrix_r[i][j] += r*matrix_b[k][j];
            }
            }
        }
        }

        /* Now finish remaining j values */
        for (i = 0; i<size; i++) {
        for (k = en; k < size; k++) {
            r = matrix_a[i][k];
            for (j = en; j < size; j++) {
            matrix_r[i][j] += r*matrix_b[k][j];
            }
        }
        }
    }

    public void mm_bijk() {
        int i, j, k, kk, jj;
        int sum;
        int en = bsize * (size/bsize); /* Amount that fits evenly into blocks */

        for (i = 0; i < size; i++)
        for (j = 0; j < size; j++)
            matrix_r[i][j] = 0;

        for (kk = 0; kk < en; kk += bsize) {
        for (jj = 0; jj < en; jj += bsize) {
            for (i = 0; i < size; i++) {
            for (j = jj; j < jj + bsize; j++) {
                sum = matrix_r[i][j];
                for (k = kk; k < kk + bsize; k++) {
                sum += matrix_a[i][k]*matrix_b[k][j];
                }
                matrix_r[i][j] = sum;
            }
            }
        }
        /* $end bmm-ijk */
        /* Now finish off rest of j values  (not shown in textbook) */
        for (i = 0; i < size; i++) {
            for (j = en; j < size; j++) {
            sum = matrix_r[i][j];
            for (k = kk; k < kk + bsize; k++) {
                sum += matrix_a[i][k]*matrix_b[k][j];
            }
            matrix_r[i][j] = sum;
            }
        }
        /* $begin bmm-ijk */
        }
        /* $end bmm-ijk */
        /* Now finish remaining k values (not shown in textbook) */ 
        for (jj = 0; jj < en; jj += bsize) {
        for (i = 0; i < size; i++) {
            for (j = jj; j < jj + bsize; j++) {
            sum = matrix_r[i][j];
            for (k = en; k < size; k++) {
                sum += matrix_a[i][k]*matrix_b[k][j];
            }
            matrix_r[i][j] = sum;
            }
        }
        }

        /* Now finish off rest of j values (not shown in textbook) */
        for (i = 0; i < size; i++) {
        for (j = en; j < size; j++) {
            sum = matrix_r[i][j];
            for (k = en; k < size; k++) {
            sum += matrix_a[i][k]*matrix_b[k][j];
            }
            matrix_r[i][j] = sum;
        }
        }
    }

}
