package com;

public class ParFib implements Runnable {
    private int value;
    private int init_lvl;
    private int init_n;

    public ParFib(int n, int lvl) {
        init_lvl = lvl;
        init_n = n;

    }

    @Override
    public void run() {
        value = parfib(init_n, init_lvl);
    }

    private static void join(Thread t) {
        try {
            t.join();
        } catch (InterruptedException e) {
            System.out.println("ERROR: Failed to synchronize");
        }
    }

    private static int parfib (int n, int lvl) {
        if (n < 2) {
            return 0;
        }
        else {
            if (lvl > 1) {
                ParFib newPF = new ParFib(n-2, lvl-1);
                Thread childThread = new Thread(newPF);
                childThread.start();
                int leftval = parfib (n-1, lvl-1);
                join(childThread);
                return leftval + newPF.getValue();
            }
            else {
                return fib(n);
            }
        }
    }

    public static int fib(int n) {
        if (n < 2) {
            return 0;
        }
        else {
            return fib(n-1) + fib(n-2);
        }
    }

    public int getValue() {
        return value;
    }
 }

