
package com.example;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

import com.ParFib;

@BenchmarkMode(Mode.Throughput)
@OutputTimeUnit(TimeUnit.SECONDS)

public class FibBenchmark {

// Simple Fib bench

    @Benchmark
    @Fork(1)
    @Warmup(iterations = 1)
    @Measurement(iterations = 3)
    public int testMethod() {
        ParFib pj = new ParFib(40,1);
        pj.run();
        return pj.getValue();
    }

// Parallel Fib bench

    @Benchmark
    @Fork(2)
    @Warmup(iterations = 1)
    @Measurement(iterations = 3)
    public int testMethodPar() {
        ParFib pj = new ParFib(40,4);
        pj.run();
        return pj.getValue();
    }

}
